#include <stdio.h>
#include <string.h>

#include "CrashDllOne.h"
#include "CrashDllTwo.h"
// Prototypes

// Returns for ProcessCommandLine.
#define SHOW_USAGE      -1
#define CRASH_IN_EXE    0
#define CRASH_IN_DLLONE 1
#define CRASH_IN_DLLTWO 2
int ProcessCommandLine ( int argc , char * argv[] ) ;
// Shows usage stuff.
void ShowUsage ( void ) ;
// The function that crashes in the EXE.
void CrashInExe ( void ) ;

// Starts here.
void main ( int argc , char * argv[] )
{
    // Process the command line parameters.
    int iRet = ProcessCommandLine ( argc , argv ) ;

    // Process life as we know it.
    switch ( iRet )
    {
        case SHOW_USAGE         :
            ShowUsage ( ) ;
            break ;
        case CRASH_IN_EXE       :
            CrashInExe ( ) ;
            break ;
        case CRASH_IN_DLLONE    :
            CrashInDllOne ( ) ;
            break ;
        case CRASH_IN_DLLTWO    :
            CrashInDllTwo ( ) ;
            break ;
        default                 :
            printf ( "I DON'T KNOW HOW I GOT HERE!!!!\n" ) ;
            break ;
    }
}

int ProcessCommandLine ( int argc , char * argv[] )
{
    if ( argc < 2 )
    {
        // Show the usage.
        return ( SHOW_USAGE ) ;
    }
    if ( 0 == stricmp ( "-m" , argv[ 1 ] ) )
    {
        // Crash in this EXE.
        return ( CRASH_IN_EXE ) ;
    }
    else if ( 0 == stricmp ( "-d1" , argv[ 1 ] ) )
    {
        // Crash in DLL one.
        return ( CRASH_IN_DLLONE ) ;
    }
    else if ( 0 == stricmp ( "-d2" , argv[ 1 ] ) )
    {
        // Crash in DLL two.
        return ( CRASH_IN_DLLTWO ) ;
    }
    // Show the usage.
    return ( SHOW_USAGE ) ;
}

void ShowUsage ( void )
{
    printf ( "CrashOmatic - It just crashes!\n"             ) ;
    printf ( "  Specify either of the following command "
             "line parameters to dictate where the\n  crash "
             "happens:\n"                                   ) ;
    printf ( "     -m   Crash in the EXE\n"                 ) ;
    printf ( "     -d1  Crash in DLL one\n"                 ) ;
    printf ( "     -d2  Crash in DLL two\n"                 ) ;
}

void CrashInExe ( void )
{
    // Crash away....
    char * p = NULL ;
    *p = 'p' ;
}
