VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CCustomers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Setting: Supports transactions
Option Explicit

Public Sub GetInfo(ByVal Customer As String, ByRef CreditLimit As Currency, ByRef AccountBalance As Currency)
  Dim sSQL As String, Quantity As Long
  sSQL = "SELECT CreditLimit, AccountBalance" & _
        " FROM Customers" & _
        " WHERE Customer = '" & Customer & "'"
  Dim rs As New ADODB.Recordset
  rs.CursorType = adOpenStatic
  rs.Open sSQL, sConnect
  ' make sure customer exists
  If rs.RecordCount = 0 Then
    rs.Close
    Set rs = Nothing
    Dim ErrDesc As String
    ErrDesc = "Customer '" & Customer & "' not found"
    Err.Raise meCustomerNotFound, , ErrDesc
  End If
  CreditLimit = rs.Fields("CreditLimit")
  AccountBalance = rs.Fields("AccountBalance")
  rs.Close
End Sub


Public Sub Charge(ByVal Customer As String, ByVal Price As Currency)

  Dim ObjCtx As ObjectContext
  Set ObjCtx = GetObjectContext()
  
  Dim conn As New ADODB.Connection
  conn.Open sConnect

  ' chck available credit agianst price of order
  Dim AvailableCredit As Currency
  AvailableCredit = GetAvailableCredit(Customer, conn)
  If (AvailableCredit < Price) Then
    ObjCtx.SetAbort
    Dim Desc As String
    Desc = Format(Price, "$#,##0.00") & _
           " exceeds available credit balance of " & _
           Format(AvailableCredit, "$#,##0.00")
    Err.Raise meOrderExceedsAvailableCredit, , Desc
  End If
  
  ' add price to customers account balance
  Dim sSQL As String
  sSQL = "UPDATE Customers" & _
        " SET AccountBalance = AccountBalance + " & Price & _
        " WHERE Customer = '" & Customer & "'"
  
  conn.Execute sSQL
  conn.Close
  
  ObjCtx.SetComplete
  
End Sub

Private Function GetAvailableCredit(ByVal Customer As String, conn As ADODB.Connection) As Currency

  Dim ObjCtx As ObjectContext
  Set ObjCtx = GetObjectContext()
  
  Dim sSQL As String, Quantity As Long
  sSQL = "SELECT CreditLimit, AccountBalance" & _
        " FROM Customers" & _
        " WHERE Customer = '" & Customer & "'"
  Dim rs As New ADODB.Recordset
  Set rs.ActiveConnection = conn
  rs.CursorType = adOpenStatic
  rs.Open sSQL, sConnect
  If rs.RecordCount = 0 Then
    ObjCtx.SetAbort
    conn.Close
    Set conn = Nothing
    Dim ErrDesc As String
    ErrDesc = "Customer '" & Customer & "' not found"
    Err.Raise meCustomerNotFound, , ErrDesc
  End If
  GetAvailableCredit = rs.Fields("CreditLimit") - rs.Fields("AccountBalance")
End Function

