VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CProducts"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
' Setting: Supports transactions
Option Explicit

Private Const MaxOrderPercentage = 0.5

Public Function Purchase(ByVal Product As String, ByVal Quantity As Integer) As Currency

  Dim ObjCtx As ObjectContext
  Set ObjCtx = GetObjectContext()

  Dim conn As New ADODB.Connection
  conn.Open sConnect

  ' check inventory level
  Dim InventoryQuantity As Long
  InventoryQuantity = InventoryCount(Product, conn)
  
  ' see if product is in stock
  Dim ErrDesc As String
  If (InventoryQuantity = 0) Then
    ObjCtx.SetAbort
    conn.Close
    Set conn = Nothing
    ErrDesc = "There are no " & Product & " currently in stock"
    Err.Raise meProductNotInStock, , ErrDesc
  End If
  
  ' see if quantity exceed maximum order percentage
  If (Quantity > (InventoryQuantity * MaxOrderPercentage)) And _
     (Quantity <> 1) _
  Then
    ObjCtx.SetAbort
    conn.Close
    Set conn = Nothing
    ErrDesc = "There are only " & InventoryQuantity & " " & Product & vbCrLf
    ErrDesc = ErrDesc & "You cannot purchase more than " & Format(MaxOrderPercentage, "00.0%") & " of what is currently in stock"
    Err.Raise meQuantityNotAvailable, , ErrDesc
  End If
  
  ' decrement inventory count
  Dim sSQL As String
  sSQL = "UPDATE Products" & _
        " SET Quantity = Quantity - " & Quantity & _
        " WHERE Product = '" & Product & "'"
  conn.Execute sSQL
  
  ' return purchase price as return value
  Purchase = Quantity * ProductPrice(Product, conn)
  
  conn.Close
  
  ObjCtx.SetComplete
  
End Function

Private Function InventoryCount(ByVal Product As String, conn As ADODB.Connection) As Long


  Dim ObjCtx As ObjectContext
  Set ObjCtx = GetObjectContext()
  
  Dim sSQL As String, Quantity As Long
  sSQL = "SELECT Quantity FROM Products WHERE Product = '" & Product & "'"
  Dim rs As New ADODB.Recordset
  rs.CursorType = adOpenStatic
  Set rs.ActiveConnection = conn
  rs.Open sSQL, sConnect
  If rs.RecordCount = 0 Then
    ObjCtx.SetAbort
    rs.Close
    Set rs = Nothing
    Dim ErrDesc As String
    ErrDesc = "The product '" & Product & "' was not found"
    Err.Raise meProductNotFound, , ErrDesc
  End If
  InventoryCount = rs.Fields("Quantity")
End Function

Private Function ProductPrice(ByVal Product As String, conn As ADODB.Connection) As Currency
  Dim sSQL As String, Quantity As Long
  sSQL = "SELECT Price FROM Products WHERE Product = '" & Product & "'"
  Dim rs As New ADODB.Recordset
  rs.CursorType = adOpenStatic
  Set rs.ActiveConnection = conn
  rs.Open sSQL, sConnect
  ProductPrice = rs.Fields("Price")
End Function

Function GetList() As Variant
  Dim sSQL As String, iProductCount As Long
  sSQL = "SELECT Product Product FROM Products"
  Dim rs As New ADODB.Recordset
  rs.CursorType = adOpenStatic
  rs.Open sSQL, sConnect
  GetList = rs.GetRows()
End Function

Function GetListWithInfo() As Variant
  Dim sSQL As String, iProductCount As Long
  sSQL = "SELECT * FROM Products"
  Dim rs As New ADODB.Recordset
  rs.CursorType = adOpenStatic
  rs.Open sSQL, sConnect
  rs.MoveLast
  rs.MoveFirst
  iProductCount = rs.RecordCount
  Dim Products() As Variant, i As Long
  ReDim Products(iProductCount - 1)
  For i = 0 To (iProductCount - 1)
    Products(i) = rs.Fields("Quantity") & " " & _
                  LCase(rs.Fields("Product")) & " in stock " & _
                  "at " & Format(rs.Fields("Price"), "$0.00") & " each"
    rs.MoveNext
  Next i
  rs.Close
  GetListWithInfo = Products
End Function



