#include <windows.h>
#include <httpfilt.h>

#define FILENAME "getie.htm"


BOOL WINAPI GetFilterVersion (PHTTP_FILTER_VERSION pFilterVersion)
{
   pFilterVersion->dwFilterVersion = HTTP_FILTER_REVISION;
   
   strcpy (pFilterVersion->lpszFilterDesc,"Smart Redir Filter");
   pFilterVersion->dwFlags= (	SF_NOTIFY_ORDER_HIGH     | 
								SF_NOTIFY_SECURE_PORT    |
								SF_NOTIFY_NONSECURE_PORT |
								SF_NOTIFY_URL_MAP  
        						);
  return TRUE;
}  


DWORD WINAPI HttpFilterProc (PHTTP_FILTER_CONTEXT pFC,
                             DWORD dwNotificationType,
                             LPVOID pvNotification)
{
    HTTP_FILTER_URL_MAP *pUrlMap;
    CHAR  szTemp [256], *lpszUserAgent, *lpszServer; 
    DWORD dwSize = 0;

	if (dwNotificationType == SF_NOTIFY_URL_MAP)
    {
        pUrlMap = (HTTP_FILTER_URL_MAP *) pvNotification;
		if (strstr (strlwr ((CHAR *)pUrlMap->pszURL), "ieonly") )
		{
			// This call should fail w/error ERROR_INSUFFICIENT_BUFFER
			//  you should check, for other errors.
			pFC->GetServerVariable (pFC,"HTTP_USER_AGENT", 
                                         lpszUserAgent,&dwSize);
			lpszUserAgent = (CHAR *) pFC->AllocMem (pFC,dwSize,0);

            // request is to IEONLY directory, check user agent 
            if (!pFC->GetServerVariable (pFC,"HTTP_USER_AGENT", 
                                         lpszUserAgent,&dwSize))
		    {
				pFC->ServerSupportFunction (pFC, SF_REQ_SEND_RESPONSE_HEADER,
					                           (PVOID) "200 OK", 0,0); 
                wsprintf (szTemp, "GetServerVariable failed: %d", 
                          GetLastError());
                dwSize = lstrlen (szTemp);
                pFC -> WriteClient (pFC, szTemp, &dwSize, 0);
		        return SF_STATUS_REQ_FINISHED;
		    }
            if (!strstr (strlwr (lpszUserAgent), "msie 4") ) 
            {
                // not an IE 4.0 browser, redirect client
                // Get the name of the server. But first determine size
				// of the buffer.
				dwSize = 0;
				pFC->GetServerVariable (pFC,"SERVER_NAME", 
                                         lpszServer,&dwSize);
				lpszServer = (CHAR *) pFC->AllocMem (pFC,dwSize,0);
                if (!pFC->GetServerVariable (pFC,"SERVER_NAME", 
                                         lpszServer,&dwSize))
				{
					pFC->ServerSupportFunction (pFC, SF_REQ_SEND_RESPONSE_HEADER,
					                           (PVOID) "200 OK", 0,0); 
		            wsprintf (szTemp, "GetServerVariable failed: %lu", GetLastError());
					dwSize = lstrlen (szTemp);
					pFC -> WriteClient (pFC, szTemp, &dwSize, 0);										
					return SF_STATUS_REQ_FINISHED;
				}

				wsprintf (szTemp, "Location: http://%s/%s\r\n\r\n", 
				          lpszServer, FILENAME);
				pFC->ServerSupportFunction (pFC, SF_REQ_SEND_RESPONSE_HEADER,
				                           (PVOID) "302 Redirect",
										   (DWORD) szTemp,0); 
				return SF_STATUS_REQ_FINISHED;
				
			}	
		}		
	 }		
	 return SF_STATUS_REQ_NEXT_NOTIFICATION; 
}

